#include <os.h>
#include "fileio.h"
#include "filebrowser.h"

int open(uint8_t* scrbuf, FILE* file, char* path, char* savepath, char* textbuffer, int* pos, int* cursorscreenrow){
    #ifndef NO_FILEBROWSER
    char tmp[FILENAME_MAX];
    int filebrowsererror;
    unsigned button;
    int filelen;
    button = show_msgbox_2b("Document not saved!", "Save Document?", "Yes", "No");
    if(button == 1){//if yes chosen
        if(save(scrbuf, file, path, savepath, textbuffer) == 1){//if error
            file = fopen(strcat(path,"noname.txt.tns"), "wb");
            fwrite(textbuffer, 1, strlen(textbuffer), file);
            fclose(file);
        }
    }
    if((filebrowsererror = filebrowser(scrbuf, tmp)) == 1)
        return 1;
    #else
    char* tmp;
    int inputlen;
    int filelen;
    wait_no_key_pressed();
    inputlen = show_msg_user_input("Open File", "", path, &tmp);
    if(inputlen == -1)
        return 1;
    strcpy(savepath, tmp);
    free(tmp);
    #endif
    strcpy(savepath, tmp);
    file = fopen(savepath,"rb");
    if(file == NULL)
        return 1;
    fseek(file, 0, SEEK_END);
    filelen = ftell(file);
    printf("filelen %i\n",filelen);
    rewind(file);
    free(textbuffer);
    textbuffer = malloc(filelen + 1024 - (filelen%1024));
    if(textbuffer == NULL)
        return 1;
    fread(textbuffer, 1, filelen, file);
    fclose(file);
    textbuffer[filelen] = '\0';
    *pos = 0;
    *cursorscreenrow = 0;
    return 0;
}

int save(uint8_t* scrbuf, FILE* file, char* path, char* savepath, char* textbuffer){
    if(strlen(savepath) == 0)
        return saveAs(scrbuf, file, path, savepath, textbuffer);
    else{
        file = fopen(savepath,"wb");
        fwrite(textbuffer,1,strlen(textbuffer),file);
        fclose(file);
        return 0;
    }
}

int saveAs(uint8_t* scrbuf, FILE* file, char* path, char* savepath, char* textbuffer){
    char* tmp;
    int inputlen = 0;
    wait_no_key_pressed();
    inputlen = show_msg_user_input("Save file as", "", path, &tmp);
    if(inputlen == -1 || inputlen > 247){
        show_msgbox("", "Document not saved!");
        return 1;
    }
    strcpy(savepath,tmp);
    free(tmp);
    if(strstr(savepath, ".txt.tns") != strrchr(savepath, '\0') - 8){
        if(show_msgbox_2b("Path doesn't end with .txt.tns", "Append .txt.tns to the path?", "Yes", "No") == 1)
            strcat(savepath, ".txt.tns");
    }
    file = fopen(savepath, "r");
    if(file != NULL){
        fclose(file);
        if(show_msgbox_2b("Save As","File already exists! Do you really want to overwrite it?", "Yes", "No") == 2)
            return 1;
    }
    file = fopen(savepath,"wb");
    fwrite(textbuffer,1,strlen(textbuffer),file);
    fclose(file);
    return 0;
}
